# PyGreSQLDriver

import slogan.databases
import pg

# If the DB server is on localhost, use Unix sockets not TCP/IP, since many
# PostgreSQL setups by default disallow TCP/IP connections.

# The pg module already returns results in a mapping so we don't need to
# convert it in the query method.

class Driver(slogan.databases.Driver):
  identity= 'pygresql'

  def connect(self, host, database, user, password):
    if host=='localhost':
      host= None
    self.connection= pg.connect(database, host, -1, None, None, user, password)
  def disconnect(self):
    self.connection.close()

  def command(self, sql):
    self.connection.query(sql)
  def query(self, sql):
    return self.connection.query(sql).dictresult()
