# FileTrait

import slogan, slogan.traits, slogan.traits.type
import string, mimetypes

# Trait for name-of-file-that-was-served. Each pathname element becomes a
# list element.

class Trait(slogan.traits.Trait):
  identity= 'file'
  extended= 'cs-uri-stem'
  priority= 110
  size= [32]*6
  def __init__(self):
    self.title= slogan.language.file_title

  def read(self, logpart):
    if logpart[-1:]=='/':
      logpart= logpart+slogan.config['fileIndex']
    return filter(lambda x: x!='', string.split(logpart[1:], '/'))

  def write(self, partlist):
    return '/'+string.join(filter(lambda x: x!='', partlist), '/')

# File icons are derived from their extension rather than their path. Attempt
# to convert the extension into a MIME type, and get TypeTrait to give the
# icon name.

  def icon(self, partlist):
    if len(partlist)==0:
      return ['type', 'directory']
    if '.' not in partlist[-1]:
      return ['type', 'directory']
    mime= mimetypes.guess_type(partlist[-1])[0]
    if mime==None:
      return ['type', 'file']
    return slogan.traitObjects['type'].icon(string.split(mime, '/', 1))
