# TypeTrait

import slogan, slogan.traits
import string

# MIME type of requested document

class Trait(slogan.traits.Trait):
  identity= 'type'
  extended= 'sc(Content-Type)'
  priority= 40
  size= [12, 24]
  def __init__(self):
    self.title= slogan.language.type_title

  def read(self, logpart):
    return string.split(logpart, '/', 1)

  def write(self, partlist):
    if len(partlist)>0 and partlist[0]!='':
      return string.join(partlist, '/')
    return slogan.language.type_none

# Icons are kept without the 'x-' prefix because people seem to prefer
# to use or not use it at random

  def icon(self, partlist):
    def stripXs(part):
      if part[:2]=='x-':
        return part[2:]
      else:
        return part
    return ['type', 'file']+map(stripXs, partlist)
